sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=234
left=96
sizeHControl=0
sizeVControl=0
caption="NewBASIC Eyes 0.1"
tileLayout=1
End CompInit
Dim label1 as label
label1 = MakeComponent("label",form1)
CompInit label1
proto="label1"
caption=""
sizeHControl=3
sizeVControl=3
left=0
top=85
visible=1
End CompInit
label1.name="label1"
Dim gadget2 as gadget
gadget2 = MakeComponent("gadget",form1)
CompInit gadget2
proto="gadget2"
width=291
left=0
top=2
height=100
visible=1
End CompInit
Dim text1 as text
text1 = MakeComponent("text",gadget2)
CompInit text1
proto="text1"
left=107
top=47
height=50
look=3
maxChars=2000
maxLines=0
End CompInit
text1.name="text1"
text1.visible=1
gadget2.name="gadget2"
Dim button1 as button
button1 = MakeComponent("button",form1)
CompInit button1
proto="button1"
caption="Let's go..."
left=110
top=110
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
button1.name="button1"
form1.name="form1"
form1.height=170
form1.width=300
Dim dialog1 as dialog
dialog1 = MakeComponent("dialog","app")
CompInit dialog1
proto="dialog1"
left=164
top=103
tile=1
caption=""
tileLayout=1
End CompInit
Dim picture1 as picture
picture1 = MakeComponent("picture",dialog1)
CompInit picture1
proto="picture1"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
picture1.name="picture1"
picture1.graphic=GetComplex(0)
Dim picture2 as picture
picture2 = MakeComponent("picture",dialog1)
CompInit picture2
proto="picture2"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
picture2.name="picture2"
picture2.graphic=GetComplex(1)
Dim picture3 as picture
picture3 = MakeComponent("picture",dialog1)
CompInit picture3
proto="picture3"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
picture3.name="picture3"
picture3.graphic=GetComplex(2)
Dim picture4 as picture
picture4 = MakeComponent("picture",dialog1)
CompInit picture4
proto="picture4"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
picture4.name="picture4"
picture4.graphic=GetComplex(3)
Dim picture5 as picture
picture5 = MakeComponent("picture",dialog1)
CompInit picture5
proto="picture5"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
picture5.name="picture5"
picture5.graphic=GetComplex(4)
Dim picture6 as picture
picture6 = MakeComponent("picture",dialog1)
CompInit picture6
proto="picture6"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
picture6.name="picture6"
picture6.graphic=GetComplex(5)
Dim picture7 as picture
picture7 = MakeComponent("picture",dialog1)
CompInit picture7
proto="picture7"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
picture7.name="picture7"
picture7.graphic=GetComplex(6)
Dim picture8 as picture
picture8 = MakeComponent("picture",dialog1)
CompInit picture8
proto="picture8"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
picture8.name="picture8"
picture8.graphic=GetComplex(7)
Dim picture9 as picture
picture9 = MakeComponent("picture",dialog1)
CompInit picture9
proto="picture9"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
picture9.name="picture9"
picture9.graphic=GetComplex(8)
dialog1.name="dialog1"
dialog1.width=796
dialog1.height=124
Dim floater1 as floater
floater1 = MakeComponent("floater","app")
CompInit floater1
proto="floater1"
left=0
top=0
End CompInit
Dim gadget1 as gadget
gadget1 = MakeComponent("gadget",floater1)
CompInit gadget1
proto="gadget1"
width=300
height=300
left=0
top=0
visible=1
End CompInit
gadget1.name="gadget1"
floater1.name="floater1"
floater1.caption="floater1"
Dim display1 as display
display1 = MakeComponent("display","app")
CompInit display1
proto="display1"
End CompInit
display1.name="display1"
Dim timer1 as timer
timer1 = MakeComponent("timer","app")
CompInit timer1
proto="timer1"
End CompInit
timer1.name="timer1"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

DIM messageLength AS integer
messageLength = 21

DIM message[messageLength] AS string
message[0]="B"
message[1]="y"
message[2]=" "
message[3]="D"
message[4]="o"
message[5]="m"
message[6]="i"
message[7]="n"
message[8]="i"
message[9]="q"
message[10]="u"
message[11]="e"
message[12]=" "
message[13]="V"
message[14]="o"
message[15]="c"
message[16]="a"
message[17]="t"
message[18]=" "
message[19]=" "
message[20]=" "

DIM i AS integer

timer1.interval = 30
REM timer1.enabled = 1

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

timer1.enabled = 1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

timer1.enabled = 0

end sub

sub module_exit()

end sub

sub gadget1_draw(self as gadget)

self.DrawRect(0, 0, gadget1.width, gadget1.height, WHITE)
		REM draw vertical lines of grid
'	self.DrawLine( gadget1.width/3, 0, gadget1.width/3, gadget1.height, BLACK)
'	self.DrawLine( (gadget1.width/3)*2, 0, (gadget1.width/3)*2, gadget1.height, BLACK)
		REM draw horizontal lines of grid
'	self.DrawLine( 0, gadget1.height/3, gadget1.width, gadget1.height/3, BLACK)
'	self.DrawLine( 0, (gadget1.height/3)*2, gadget1.width, (gadget1.height/3)*2, BLACK)

self.DrawText( "Klick anywhere to exit...", 92, 48, BLACK, "URW Roman", 16, 0)


end sub

sub gadget1_mouse(self as gadget, action as integer, flag as integer, X as integer, Y as integer, modifier as integer)

REM as you can see it is only a dummy
DIM dummy AS integer

REM Parse the position of the mouse and display the respective picture
IF Y >= 0 AND Y <= gadget1.height/3 AND X >= 0 AND X <= gadget1.width/3 THEN
	self.DrawImage(picture1.graphic, gadget1.width/2 - 44, gadget1.height/2 - 44)
ELSE IF Y > gadget1.height/3 AND Y <= (gadget1.height/3)*2 AND X >= 0 AND X <= gadget1.width/3 THEN
	self.DrawImage(picture4.graphic, gadget1.width/2 - 44, gadget1.height/2 - 44)
ELSE IF Y > (gadget1.height/3)*2 AND Y <= gadget1.height AND X >= 0 AND X <= gadget1.width/3 THEN
	self.DrawImage(picture7.graphic, gadget1.width/2 - 44, gadget1.height/2 - 44)
ELSE IF Y >= 0 AND Y <= gadget1.height/3 AND X > gadget1.width/3 AND X <= (gadget1.width/3)*2 THEN
	self.DrawImage(picture2.graphic, gadget1.width/2 - 44, gadget1.height/2 - 44)
ELSE IF Y > gadget1.height/3 AND Y <= (gadget1.height/3)*2 AND X > gadget1.width/3 AND X <= (gadget1.width/3)*2 THEN
	self.DrawImage(picture5.graphic, gadget1.width/2 - 44, gadget1.height/2 - 44)
ELSE IF Y > (gadget1.height/3)*2 AND Y <= gadget1.height AND X > gadget1.width/3 AND X <= (gadget1.width/3)*2 THEN
	self.DrawImage(picture8.graphic, gadget1.width/2 - 44, gadget1.height/2 - 44)
ELSE IF Y >= 0 AND Y <= gadget1.height/3 AND X > (gadget1.width/3)*2 AND X <= gadget1.width THEN
	self.DrawImage(picture3.graphic, gadget1.width/2 - 44, gadget1.height/2 - 44)
ELSE IF Y > gadget1.height/3 AND Y <= (gadget1.height/3)*2 AND X > (gadget1.width/3)*2 AND X <= gadget1.width THEN
	self.DrawImage(picture6.graphic, gadget1.width/2 - 44, gadget1.height/2 - 44)
ELSE IF Y > (gadget1.height/3)*2 AND Y <= gadget1.height AND X > (gadget1.width/3)*2 AND X <= gadget1.width THEN
	self.DrawImage(picture9.graphic, gadget1.width/2 - 44, gadget1.height/2 - 44)
END IF

REM as the user gets bored he will probably klick
IF action = 1 THEN
	floater1.visible = 0
END IF
	
end sub

sub gadget2_draw(self as gadget)

self.DrawImage(picture5.graphic, 5, 5)
self.DrawText( "NewBASIC Eyes", 92, 5, BLACK, "URW Roman", 22, 0)

end sub

sub button1_pressed(self as button)

floater1.height = display1.height
floater1.width = display1.width
gadget1.height = display1.height
gadget1.width = display1.width

floater1.visible = 1

end sub

sub timer1_ring(self as timer)

IF i < messageLength
	text1.text = text1.text + message[i]
		i = i + 1
ELSE
	text1.text = ""
		i = 0
END IF

end sub

