sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=44
left=91
sizeHControl=0
sizeVControl=0
caption="NewBASIC"
End CompInit
Dim Testen as button
Testen = MakeComponent("button",form1)
CompInit Testen
proto="Testen"
caption="Testen"
sizeHControl=3
sizeVControl=3
left=67
top=213
visible=1
End CompInit
Testen.name="Testen"
Dim TitelFrame1 as label
TitelFrame1 = MakeComponent("label",form1)
CompInit TitelFrame1
proto="TitelFrame1"
caption="Vokabeltrainer Franzsisch"
sizeHControl=3
left=80
top=16
sizeVControl=3
visible=1
End CompInit
TitelFrame1.name="TitelFrame1"
Dim PunkteButton as button
PunkteButton = MakeComponent("button",form1)
CompInit PunkteButton
proto="PunkteButton"
caption="bungsergebni"
left=140
top=213
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
PunkteButton.name="PunkteButton"
Dim DateiMenue as popup
DateiMenue = MakeComponent("popup",form1)
CompInit DateiMenue
proto="DateiMenue"
caption="Datei"
left=0
top=0
visible=1
End CompInit
Dim InfoButton as button
InfoButton = MakeComponent("button",DateiMenue)
CompInit InfoButton
proto="InfoButton"
caption="Info"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
InfoButton.name="InfoButton"
Dim AutorButton as button
AutorButton = MakeComponent("button",DateiMenue)
CompInit AutorButton
proto="Autorbutton"
caption="Autor"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
AutorButton.name="AutorButton"
Dim EndeButton as button
EndeButton = MakeComponent("button",DateiMenue)
CompInit EndeButton
proto="EndeButton"
caption="EXIT"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
EndeButton.name="EndeButton"
DateiMenue.name="DateiMenue"
Dim LektionMenue as popup
LektionMenue = MakeComponent("popup",form1)
CompInit LektionMenue
proto="LektionMenue"
caption="Lektion"
left=0
top=0
visible=1
End CompInit
Dim Lektion1Button as button
Lektion1Button = MakeComponent("button",LektionMenue)
CompInit Lektion1Button
proto="Lektion1Button"
caption="Lektion 1"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Lektion1Button.name="Lektion1Button"
Dim Lektion2Button as button
Lektion2Button = MakeComponent("button",LektionMenue)
CompInit Lektion2Button
proto="Lektion2Button"
caption="Lektion 2"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Lektion2Button.name="Lektion2Button"
Dim Lektion3Button as button
Lektion3Button = MakeComponent("button",LektionMenue)
CompInit Lektion3Button
proto="Lektion3Button"
caption="Lektion 3"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Lektion3Button.name="Lektion3Button"
Dim Lektion4Button as button
Lektion4Button = MakeComponent("button",LektionMenue)
CompInit Lektion4Button
proto="Lektion4Button"
caption="Lektion 4"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Lektion4Button.name="Lektion4Button"
LektionMenue.name="LektionMenue"
Dim AufgabeGroup as group
AufgabeGroup = MakeComponent("group",form1)
CompInit AufgabeGroup
proto="AufgabeGroup"
caption="Bitte diese Vokabel bersetzen:"
left=10
top=34
height=80
width=292
look=1
tile=1
tileLayout=1
visible=1
End CompInit
Dim FrageVokabelText as text
FrageVokabelText = MakeComponent("text",AufgabeGroup)
CompInit FrageVokabelText
proto="FrageVokabelText"
readOnly=1
look=1
width=250
height=48
End CompInit
FrageVokabelText.name="FrageVokabelText"
FrageVokabelText.visible=1
Dim FrageVokabelScrollBar as scrollbar
FrageVokabelScrollBar = MakeComponent("scrollbar",AufgabeGroup)
CompInit FrageVokabelScrollBar
proto="FrageVokabelScrollBar"
sizeHControl=0
sizeVControl=0
height=52
width=15
visible=1
End CompInit
FrageVokabelScrollBar.name="FrageVokabelScrollBar"
AufgabeGroup.name="AufgabeGroup"
Dim LektionAktuellPopUp as popup
LektionAktuellPopUp = MakeComponent("popup",form1)
CompInit LektionAktuellPopUp
proto="LektionAktuellPopUp"
caption="Lektion 1 gewhlt"
left=0
top=0
visible=1
End CompInit
LektionAktuellPopUp.name="LektionAktuellPopUp"
Dim AntwortGroup as group
AntwortGroup = MakeComponent("group",form1)
CompInit AntwortGroup
proto="Antwortroup"
caption="Bitte hier die bersetzung eingeben:"
left=10
top=124
height=80
width=292
look=1
tile=1
tileLayout=1
visible=1
End CompInit
Dim AntwortText as text
AntwortText = MakeComponent("text",AntwortGroup)
CompInit AntwortText
proto="AntwortText"
height=48
width=250
look=1
End CompInit
AntwortText.name="AntwortText"
AntwortText.visible=1
Dim AntwortScrollBar as scrollbar
AntwortScrollBar = MakeComponent("scrollbar",AntwortGroup)
CompInit AntwortScrollBar
proto="AntwortScrollBar"
sizeHControl=3
sizeVControl=0
height=52
visible=1
End CompInit
AntwortScrollBar.name="AntwortScrollBar"
AntwortGroup.name="AntwortGroup"
form1.width=319
form1.height=280
form1.name="form1"
Dim sound1 as sound
sound1 = MakeComponent("sound","app")
CompInit sound1
proto="sound1"
End CompInit
sound1.name="sound1"
Dim Erfolgdialog as dialog
Erfolgdialog = MakeComponent("dialog","app")
CompInit Erfolgdialog
proto="Erfolgdialog"
left=412
top=147
tile=1
caption="bungsergebnis"
tileSpacing=6
tileHAlign=2
sizeVControl=0
End CompInit
Dim Uebungszahllabel as label
Uebungszahllabel = MakeComponent("label",Erfolgdialog)
CompInit Uebungszahllabel
proto="Uebungszahllabel"
caption="Durchgefhrte bungen: 0"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Uebungszahllabel.name="Uebungszahllabel"
Dim Richtiglabel as label
Richtiglabel = MakeComponent("label",Erfolgdialog)
CompInit Richtiglabel
proto="Richtiglabel"
caption="Richtige Antworten: 0"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Richtiglabel.name="Richtiglabel"
Dim Prozentlabel as label
Prozentlabel = MakeComponent("label",Erfolgdialog)
CompInit Prozentlabel
proto="Prozentlabel"
caption="Quote: 0%"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Prozentlabel.name="Prozentlabel"
Erfolgdialog.height=75
Erfolgdialog.width=180
Erfolgdialog.name="Erfolgdialog"
Dim RichtigDialog as dialog
RichtigDialog = MakeComponent("dialog","app")
CompInit RichtigDialog
proto="RichtigDialog"
left=412
top=75
tile=1
caption="Richtige Lsung"
sizeHControl=0
type=2
helpContext=""
sizeVControl=0
tileSpacing=5
End CompInit
Dim RichtigTextLabel as label
RichtigTextLabel = MakeComponent("label",RichtigDialog)
CompInit RichtigTextLabel
proto="RichtigTextLabel"
caption="Die Lsung war richtig !"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
RichtigTextLabel.name="RichtigTextLabel"
Dim RichtigSchliessButton as button
RichtigSchliessButton = MakeComponent("button",RichtigDialog)
CompInit RichtigSchliessButton
proto="RichtigSchliessButton"
caption="weiter"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
RichtigSchliessButton.name="RichtigSchliessButton"
RichtigDialog.name="RichtigDialog"
RichtigDialog.width=155
RichtigDialog.height=66
Dim FalschDialog as dialog
FalschDialog = MakeComponent("dialog","app")
CompInit FalschDialog
proto="FalschDialog"
left=92
top=288
tile=1
caption="Falsche Antwort"
tileSpacing=5
type=2
helpContext=""
End CompInit
Dim FalschTextLabel as label
FalschTextLabel = MakeComponent("label",FalschDialog)
CompInit FalschTextLabel
proto="FalschTextLabel"
caption="Die Antwort war leider falsch !"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
FalschTextLabel.name="FalschTextLabel"
Dim FalschButton as button
FalschButton = MakeComponent("button",FalschDialog)
CompInit FalschButton
proto="FalschButton"
caption="weiter"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
FalschButton.name="FalschButton"
Dim RichtigGroup as group
RichtigGroup = MakeComponent("group",FalschDialog)
CompInit RichtigGroup
proto="RichtigGroup"
caption=" Richtige Lsung: "
look=1
sizeHControl=0
sizeVControl=0
tile=1
height=80
width=292
tileLayout=1
visible=1
End CompInit
Dim RichtigInfoText as text
RichtigInfoText = MakeComponent("text",RichtigGroup)
CompInit RichtigInfoText
proto="RichtigInfoText"
readOnly=1
width=250
height=48
look=1
End CompInit
RichtigInfoText.name="RichtigInfoText"
RichtigInfoText.visible=1
Dim RichtigInfoScrollBar as scrollbar
RichtigInfoScrollBar = MakeComponent("scrollbar",RichtigGroup)
CompInit RichtigInfoScrollBar
proto="RichtigInfoScrollBar"
sizeHControl=3
sizeVControl=0
height=52
visible=1
End CompInit
RichtigInfoScrollBar.name="RichtigInfoScrollBar"
RichtigGroup.name="RichtigGroup"
FalschDialog.height=155
FalschDialog.width=311
FalschDialog.name="FalschDialog"
Dim AutorInfoDialog as dialog
AutorInfoDialog = MakeComponent("dialog","app")
CompInit AutorInfoDialog
proto="AutorInfoDialog"
left=237
top=300
caption="Autoren-Info"
End CompInit
Dim AutorInfoText as text
AutorInfoText = MakeComponent("text",AutorInfoDialog)
CompInit AutorInfoText
proto="AutorInfoText"
readOnly=1
left=23
top=5
width=220
height=75
End CompInit
AutorInfoText.name="AutorInfoText"
AutorInfoText.AppendString("	    \r")
AutorInfoText.AppendString(" Vokabeltrainer  .1998\r")
AutorInfoText.AppendString("\r")
AutorInfoText.AppendString(" Jrgen Heinisch\r")
AutorInfoText.AppendString(" GEOS USER CLUB\r")
AutorInfoText.AppendString(" \r")
AutorInfoText.AppendString(" Moerser Str..11\r")
AutorInfoText.AppendString(" D-46286 Dorsten-Rhade\r")
AutorInfoText.AppendString("\r")
AutorInfoText.AppendString(" Tel.: 0049-2866-96101\r")
AutorInfoText.AppendString(" FAX: 0049-2866-96102\r")
AutorInfoText.AppendString(" eMail: jheinisch@geosuserclub.com\r")
AutorInfoText.AppendString(" www: www.geosuserclub.com\r")
AutorInfoText.AppendString(" T-Online: *geos# 02866376-0001\r")
AutorInfoText.AppendString("\r")
AutorInfoText.AppendString(" Bankverbindung:\r")
AutorInfoText.AppendString(" Postbank Essen \r")
AutorInfoText.AppendString(" Kontoinhaber: Jrgen Heinisch\r")
AutorInfoText.AppendString(" BLZ: 360.100.43\r")
AutorInfoText.AppendString(" KNr.: 4064.04-431\r")
AutorInfoText.AppendString("")
AutorInfoText.visible=1
Dim AutorInfoCloseButton as button
AutorInfoCloseButton = MakeComponent("button",AutorInfoDialog)
CompInit AutorInfoCloseButton
proto="AutorInfoCloseButton"
caption="close"
sizeHControl=3
sizeVControl=3
closeDialog=1
left=51
top=91
visible=1
End CompInit
AutorInfoCloseButton.name="AutorInfoCloseButton"
Dim AutorScrollBar as scrollbar
AutorScrollBar = MakeComponent("scrollbar",AutorInfoDialog)
CompInit AutorScrollBar
proto="AutorScrollBar"
left=244
top=5
sizeHControl=0
sizeVControl=0
height=79
width=12
visible=1
End CompInit
AutorScrollBar.name="AutorScrollBar"
Dim FotoButton as button
FotoButton = MakeComponent("button",AutorInfoDialog)
CompInit FotoButton
proto="FotoButton"
caption="Foto"
left=187
top=91
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
FotoButton.name="FotoButton"
AutorInfoDialog.height=150
AutorInfoDialog.width=280
AutorInfoDialog.name="AutorInfoDialog"
Dim FotoDialog as dialog
FotoDialog = MakeComponent("dialog","app")
CompInit FotoDialog
proto="FotoDialog"
left=515
top=247
tile=1
caption="Foto"
End CompInit
Dim AutorPicture as picture
AutorPicture = MakeComponent("picture",FotoDialog)
CompInit AutorPicture
proto="AutorPicture"
height=167
width=110
visible=1
End CompInit
AutorPicture.name="AutorPicture"
FotoDialog.height=202
FotoDialog.width=126
FotoDialog.name="FotoDialog"
Dim InfoDialog as dialog
InfoDialog = MakeComponent("dialog","app")
CompInit InfoDialog
proto="InfoDialog"
left=460
top=42
tile=1
caption="Info"
tileLayout=1
helpContext=""
End CompInit
Dim InfoText as text
InfoText = MakeComponent("text",InfoDialog)
CompInit InfoText
proto="InfoText"
readOnly=1
look=1
End CompInit
InfoText.name="InfoText"
InfoText.AppendString("Dieses Vokabellernprogramm wurde auf Basis eines Schulbuchs fr die 9. Klasse der Realschule entwickelt. Es enthlt als Vokabeln dieses Buches.\r")
InfoText.AppendString("Das Programm erklrt sich von selbst, so das ein besondere Anleitung nicht notwendig ist.")
InfoText.visible=1
Dim InfoScrollBar as scrollbar
InfoScrollBar = MakeComponent("scrollbar",InfoDialog)
CompInit InfoScrollBar
proto="InfoScrollBar"
sizeHControl=3
sizeVControl=0
height=75
visible=1
End CompInit
InfoScrollBar.name="InfoScrollBar"
InfoDialog.height=139
InfoDialog.width=280
InfoDialog.name="InfoDialog"
EnableEvents()
duplo_start()
end sub

sub duplo_start()

DIM i AS integer
DIM frage[999] AS string
DIM antwort[999] AS string
DIM anzahlvokabelsaetze AS integer
DIM position AS integer
DIM anzahluebung AS integer
DIM anzahlrichtig AS integer
DIM anzahlprozent AS integer
DIM userantwort AS string
DIM pgm_antwort AS string
DIM aktuelle_lektion AS string
DIM start_lektion AS integer
DIM ende_lektion AS integer

DIM lenBig AS integer
DIM lenLittle AS integer
DIM instr AS integer
DIM count AS integer

aktuelle_lektion = "Lektion 1"
start_lektion = 1
ende_lektion = 38
FrageVokabelText.caption = "Lektion 1 ausgewhlt"

anzahlvokabelsaetze = 333
position = 1
anzahluebung = 0
anzahlrichtig = 0
anzahlprozent = 0

FrageVokabelText.caption = frage[position]
AntwortText.text = ""

Vokabelliste_1()
Vokabelliste_2()
Vokabelliste_3()

Neue_Aufgabe()

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
Erfolgdialog.visible = 0
RichtigDialog.visible = 0
FalschDialog.visible = 0
AutorInfoDialog.visible = 0
FotoDialog.visible = 0
InfoDialog.visible = 0

end sub

sub module_exit()

end sub

sub Testen_pressed(self as button)

Auswerten()

end sub

sub PunkteButton_pressed(self as button)

Erfolgdialog.visible = 1

end sub

sub RichtigSchliessButton_pressed(self as button)

RichtigDialog.visible = 0

end sub

sub QuoteBerechnen ()

Uebungszahllabel.caption = "Durchgefhrte bungen: " + str(anzahluebung)
Richtiglabel.caption = "Richtige Antworten: " + STR(anzahlrichtig)
anzahlprozent = anzahlrichtig * 100 / anzahluebung
Prozentlabel.caption = "Quote: " + STR(anzahlprozent) + "%"

end sub

sub FalschButton_pressed(self as button)

FalschDialog.visible = 0
Neue_Aufgabe()

end sub

function INSTR(big AS string, little AS string) AS integer
	lenBig = LEN(big)
	lenLittle = LEN(little)
	instr = 0
	count = 1
	DO WHILE count <= (lenBig - lenLittle)
		IF MID(big, count, lenLittle) = little THEN
			instr = count
			count = lenBig
		END IF
		count = count + 1
	LOOP

end function

sub Antwortvokabel_entered(self as entry)

Auswerten()

end sub

sub Testen()

anzahluebung = anzahluebung + 1
userantwort = AntwortText.text
pgm_antwort = antwort[position]

IF	INSTR(pgm_antwort, userantwort) THEN
	sound1.StandardSound(5)
	anzahlrichtig = anzahlrichtig + 1
	RichtigDialog.visible = 1
else
	sound1.StandardSound(1)
	FalschDialog.visible = 1
end if

QuoteBerechnen()

position = position + 1

if position > anzahlvokabelsaetze
	position = 1
end if

FrageVokabelText.caption = frage[position]
AntwortText.text = ""

end sub

function Antwortvokabel_filterChar(self as entry, newChar as integer, replaceStart as integer, replaceEnd as integer, endOfGroup as integer) as integer

end function

sub TestenVokabel()

anzahluebung = anzahluebung + 1
userantwort = AntwortText.text
pgm_antwort = antwort[position]

IF	INSTR(pgm_antwort, userantwort) THEN
	sound1.StandardSound(5)
	anzahlrichtig = anzahlrichtig + 1
	RichtigDialog.visible = 1
else
	sound1.StandardSound(1)
	FalschDialog.visible = 1
end if

QuoteBerechnen()

position = position + 1

if position > anzahlvokabelsaetze
	position = 1
end if

FrageVokabelText.text = frage[position]
AntwortText.text = ""

end sub

sub Autorbutton_pressed(self as button)

AutorInfoDialog.visible = 1

end sub

sub Neue_Aufgabe()

if position > ende_lektion
	position = start_lektion
end if

FrageVokabelText.text = frage[position]
AntwortText.text = ""

end sub

sub RichtigDialog_aboutToClose(self as dialog)

Neue_Aufgabe()

end sub

sub FalschDialog_aboutToClose(self as dialog)

Neue_Aufgabe()

end sub

sub Auswerten()

anzahluebung = anzahluebung + 1
userantwort = AntwortText.text
pgm_antwort = antwort[position]

IF	INSTR(pgm_antwort, userantwort) THEN
	sound1.StandardSound(5)
	anzahlrichtig = anzahlrichtig + 1
	RichtigDialog.visible = 1
else
	sound1.StandardSound(1)
	RichtigInfoText.text = antwort[position]
	FalschDialog.visible = 1
end if

QuoteBerechnen()

position = position + 1

end sub

sub AutorScrollBar_changed(self as scrollbar, scrollType as integer)

	AutorInfoText.firstVisibleLine = self.value

end sub

sub AutorInfoText_scrolled(self as text)

	AutorScrollBar.value = self.firstVisibleLine

end sub

sub AutorInfoText_numLinesChanged(self as text)

	AutorScrollBar.maximum = self.numLines
	AutorScrollBar.thumbSize = self.lastVisibleLine - self.firstVisibleLine +1

end sub

sub FotoButton_pressed(self as button)

FotoDialog.visible = 1

end sub

sub EndeButton_pressed(self as button)

module_exit()

end sub

sub Lektion1Button_pressed(self as button)

start_lektion = 1
ende_lektion = 37
position = 1

LektionAktuellPopUp.caption = "Lektion 1 gewhlt"

Neue_Aufgabe()

end sub

sub Lektion2Button_pressed(self as button)

start_lektion = 38
ende_lektion = 103
position = 38

LektionAktuellPopUp.caption = "Lektion 2 gewhlt"

Neue_Aufgabe()

end sub

sub InfoButton_pressed(self as button)

InfoDialog.visible = 1

end sub

sub InfoText_scrolled(self as text)

	InfoScrollBar.value = self.firstVisibleLine

end sub

sub InfoText_numLinesChanged(self as text)

	InfoScrollBar.maximum = self.numLines
	InfoScrollBar.thumbSize = self.lastVisibleLine - self.firstVisibleLine +1

end sub

sub InfoScrollBar_changed(self as scrollbar, scrollType as integer)

	InfoText.firstVisibleLine = self.value

end sub

sub Vokabelliste_1()

frage[1] = "Da ist/Das ist Christine."
antwort[1] = "Voil Christine."
frage[2] = "Da sind/Das sind Marc und Nicole."
antwort[2] = "Voil Marc et Nicole."
frage[3] = "Gr dich! Gr euch!"
antwort[3] = "Salut!"
frage[4] = "Wie geht's?/Geht's (dir) gut?"
antwort[4] = "Ca va?"
frage[5] = "Ja,... ."
antwort[5] = "Oui. Ca va."
frage[6] = "Es geht (mir) gut."
antwort[6] = "Ca va bien."
frage[7] = "Danke."
antwort[7] = "Merci."
frage[8] = "Und du? Wie geht's (dir)?"
antwort[8] = "Et toi?"
frage[9] = "Wer ist das?"
antwort[9] = "Qui est-ce?"
frage[10] = "Das ist... ."
antwort[10] = "C'est... ."
frage[11] = "die Schwester"
antwort[11] = "la soeur"
frage[12] = "die Schwester von Pierre"
antwort[12] = "la soeur de Pierre"
frage[13] = "Und da? Und dort?"
antwort[13] = "Et l?"
frage[14] = "Ist das Marc?"
antwort[14] = "C'est Marc?"
frage[15] = "Nein."
antwort[15] = "Non."
frage[16] = "der Bruder"
antwort[16] = "le frre"
frage[17] = "Ah!Oh!Ach! (Ausruf)"
antwort[17] = "Ah!"
frage[18] = "eine Freundin von Nicole und Pierre"
antwort[18] = "une amie de Marc et de Pierre"
frage[19] = "die Freundin"
antwort[19] = "l'amie"
frage[20] = "Wer ist Marc?"
antwort[20] = "Qui est Marc?"
frage[21] = "auch"
antwort[21] = "aussi"
frage[22] = "ein Freund"
antwort[22] = "un ami"
frage[23] = "der Freund"
antwort[23] = "l'ami"
frage[24] = "Das ist auch ein Freund von Nicole."
antwort[24] = "C'est aussi un ami de Nicole."
frage[25] = "bungen"
antwort[25] = "Exercises"
frage[26] = "Zeige... !"
antwort[26] = "Montre... !"
frage[27] = "Frau Roussel, (+kurzf.)"
antwort[27] = "madame Roussel, Mme Roussel"
frage[28] = "Herr Roussel, (+kurzf.)"
antwort[28] = "monsieur Roussel, M. Roussel"
frage[29] = "die Mutter"
antwort[29] = "la mre"
frage[30] = "der Vater"
antwort[30] = "le pre"
frage[31] = "Guten Tag."
antwort[31] = "Bonjour."
frage[32] = "Mama!/die Mama"
antwort[32] = "maman!/la maman"
frage[33] = "Papa!/der Papa"
antwort[33] = "papa!/le papa"
frage[34] = "Ach, du bist Marc."
antwort[34] = "Ah! tu es Marc."
frage[35] = "Und du? Du bist Christine?"
antwort[35] = "Et toi, tu es Christine?"
frage[36] = "Ja, ich bin Christine."
antwort[36] = "Oui, je suis Christine."
frage[37] = "Auf Wiedersehen."
antwort[37] = "Au revoir."
frage[38] = "eine Familie"
antwort[38] = "une famille"
frage[39] = "eine Strae"
antwort[39] = "une rue"
frage[40] = "in; auch= an/zu/bei"
antwort[40] = ""
frage[41] = "eine Strae in Poitiers"
antwort[41] = "une rue  Poitiers"
frage[42] = "ein Hotel-Restaurant"
antwort[42] = "un hotel-restaurant"
frage[43] = "das Hotel-Restaurant von Herrn und Frau Roussel"
antwort[43] = "l'hotel-restaurant de M. et Mme Roussel"
frage[44] = "er"
antwort[44] = "il"
frage[45] = "sie"
antwort[45] = "elle"
frage[46] = "das Essen/die Mahlzeit"
antwort[46] = "le repas"
frage[47] = "zubereiten/vorbereiten"
antwort[47] = "prparer"
frage[48] = "Sie bereitet das Essen zu."
antwort[48] = "Elle prpare le repas."
frage[49] = "mit"
antwort[49] = "avec"
frage[50] = "ein Tablett"
antwort[50] = "un plateau"
frage[51] = "kommen/ankommen"
antwort[51] = "arriver"
frage[52] = "Er kommt mit einem Tablett an."
antwort[52] = "Il arrive avec un plateau."
frage[53] = "ffnen"
antwort[53] = "ouvrir"
frage[54] = "Er ffnet die Tr."
antwort[54] = "Il ouvre la porte."
frage[55] = "sein= ich bin, du bist, er ist, sie ist"
antwort[55] = "etre= je suis, tu es, il est, elle est"
frage[56] = "in"
antwort[56] = "dans"
frage[57] = "das Wohnzimmer"
antwort[57] = "la salle de sjour"
frage[58] = "Sie ist im Wohnzimmer."
antwort[58] = "Elle est dans la salle de sjour."
frage[59] = "eine Zeitschrift"
antwort[59] = "une revue"
frage[60] = "betrachten/ansehen/anschauen"
antwort[60] = "regarder"
frage[61] = "Sie betrachtet eine Zeitschrift."
antwort[61] = "Elle regarde une revue."
frage[62] = "ein (Schlaf)Zimmer"
antwort[62] = "une chambre"
frage[63] = "ein Kassettenrecorder/Tonbandgert"
antwort[63] = "un magntophone"
frage[64] = "reparieren/ausbessern"
antwort[64] = "rparer"
frage[65] = "Er repariert einen Kassettenrecorder."
antwort[65] = "Il rpare un magntophone."
frage[66] = "oder"
antwort[66] = "ou"
frage[67] = "Was ist das?"
antwort[67] = "Qu'est-ce que c'est"
frage[68] = "Was macht Ren?"
antwort[68] = "Que fait Ren?"
frage[69] = "eine Kassette"
antwort[69] = "une cassette"
frage[70] = "ein Restaurant"
antwort[70] = "un restaurant"
frage[71] = "be-/eintreten/hereinkommen= ich betrete, du betrittst, er betritt, sie betritt"
antwort[71] = "entrer= j'entre, tu entres, il entre, elle entre"
frage[78] = "Marc betritt das Restaurant."
antwort[78] = "Marc entre dans le restaurant."
frage[79] = "Tritt ein!/Komm herein!"
antwort[79] = "Entre!"
frage[80] = "Ist Pierre da?"
antwort[80] = "Est-ce que Pierre est l?"
frage[81] = "Pierre! Marc ist da!"
antwort[81] = "Pierre! C'est Marc!"
frage[82] = "arbeiten= ich arbeite, du arbeitest, er arbeitet, sie arbeitet"
antwort[82] = "travailler= je travaille, tu travailles, il travaille, elle travaille"
frage[83] = "Arbeitest du?"
antwort[83] = "Tu travailles?"
frage[84] = "aber"
antwort[84] = "mais"
frage[85] = "wo"
antwort[85] = "o"
frage[86] = "Wo ist Nicole?"
antwort[86] = "O est Nicole?"
frage[87] = "Nicole sagt guten Tag."
antwort[87] = "Nicole dit bonjour."
frage[89] = "Geschafft!"
antwort[89] = "Ca y est!"
frage[90] = "funktionieren"
antwort[90] = "marcher"
frage[91] = "anhren/zuhren"
antwort[91] = "couter"
frage[92] = "man/wir"
antwort[92] = "on"
frage[93] = "wir hren (an)"
antwort[93] = "on coute"
frage[94] = "Sollen wir eine Kassette (an)hren?"
antwort[94] = "Est-ce qu'on coute une cassette?"
frage[95] = "mgen/lieben"
antwort[95] = "aimer"
frage[96] = "Magst du Luc Tonnerre?"
antwort[96] = "Tu aimes Luc Tonnerre?"
frage[97] = "Oh, ja!/Und wie!"
antwort[97] = "Oh oui!"
frage[98] = "bringen"
antwort[98] = "apporter"
frage[99] = "suchen"
antwort[99] = "chercher"
frage[100] = "Suchst du die Kassette?"
antwort[100] = "Tu cherches la cassette?"
frage[101] = "Da ist sie!"
antwort[101] = "La voil!"
frage[102] = "dumm"
antwort[102] = "bete"
frage[103] = "Was sagt Herr Roussel?"
antwort[103] = "Que dit M. Roussel?"

end sub

sub FrageVokabelText_scrolled(self as text)

FrageVokabelScrollBar.value = self.firstVisibleLine


end sub

sub FrageVokabelText_numLinesChanged(self as text)

	FrageVokabelScrollBar.maximum = self.numLines
	FrageVokabelScrollBar.thumbSize = self.lastVisibleLine - self.firstVisibleLine +1

end sub

sub FrageVokabelScrollBar_changed(self as scrollbar, scrollType as integer)

	FrageVokabelText.firstVisibleLine = self.value

end sub

sub RichtigInfoText_scrolled(self as text)

	RichtigInfoScrollBar.value = self.firstVisibleLine

end sub

sub RichtigInfoText_numLinesChanged(self as text)

	RichtigInfoScrollBar.maximum = self.numLines
	RichtigInfoScrollBar.thumbSize = self.lastVisibleLine - self.firstVisibleLine +1

end sub

sub RichtigInfoScrollBar_changed(self as scrollbar, scrollType as integer)

	RichtigInfoText.firstVisibleLine = self.value

end sub

sub AntwortText_scrolled(self as text)

	AntwortScrollBar.value = self.firstVisibleLine

end sub

sub AntwortText_numLinesChanged(self as text)

	AntwortScrollBar.maximum = self.numLines
	AntwortScrollBar.thumbSize = self.lastVisibleLine - self.firstVisibleLine +1

end sub

sub AntwortScrollBar_changed(self as scrollbar, scrollType as integer)

	AntwortText.firstVisibleLine = self.value

end sub

sub Vokabelliste_2()

frage[104]= "Cartiers"
antwort[104]= "les Cartiers"
frage[105]= "das Camping/Zelten"
antwort[105]= "le camping"
frage[106]= "Cartiers gehen zelten/campen."
antwort[106]= "Les Cartiers font du camping."
frage[107]= "ein Gelnde/Platz"
antwort[107]= "un terrain"
frage[108]= "ein Campingplatz"
antwort[108]= "un terrain du camping"
frage[109]= "es gibt/es sind"
antwort[109]= "il y a"
frage[110]= "ein Zelt"
antwort[110]= "une tente"
frage[111]= "Zelte"
antwort[111]= "des tentes"
frage[112]= "die Zelte"
antwort[112]= "les tentes"
frage[113]= "ein Wohnwagen"
antwort[113]= "une caravane"
frage[114]= "Wohnwagen"
antwort[114]= "des caravanes"
frage[115]= "die Wohnwagen"
antwort[115]= "les caravanes"
frage[116]= "hinter"
antwort[116]= "derrire"
frage[117]= "Die Zelte sind/stehen hinter den Wohnwagen."
antwort[117]= "Les tentes sont derrire les caravanes."
frage[118]= "ein Auto"
antwort[118]= "une voiture"
frage[119]= "ankommen"
antwort[119]= "arriver"
frage[120]= "Herr Cartier und Marc kommen an. Sie kommen an."
antwort[120]= "M. Cartier et Marc arrivent. Ils arrivent."
frage[121]= "Frau Cartier und Nicole kommen an. Sie kommen an."
antwort[121]= "Mme Cartier et Nicole arrivent. Elles arrivent."
frage[122]= "wohnen"
antwort[122]= "habiter"
frage[123]= "Sie wohnen in Poitiers."
antwort[123]= "Ils habitent  Poitiers"
frage[124]= "das Wochenende; hier= am Wochenende"
antwort[124]= "le week-end"
frage[125]= "auf"
antwort[125]= "sur"
frage[126]= "Sie gehen gerne zelten/campen."
antwort[126]= "Ils aiment bien le camping."
frage[127]= "heute"
antwort[127]= "aujourd'hui"
frage[128]= "ein Stuhl"
antwort[128]= "une chaise"
frage[129]= "ein Tisch"
antwort[129]= "une table"
frage[130]= "vor (rtlich)"
antwort[130]= "devant"
frage[131]= "setzen/stellen/legen"
antwort[131]= "poser"
frage[132]= "Sie stellen einen Tisch vor den Wohnwagen."
antwort[132]= "Ils posent une table devant la caravane."
frage[133]= "ein Glas"
antwort[133]= "un verre"
frage[134]= "die Kche"
antwort[134]= "la cuisine"
frage[135]= "etwas"
antwort[135]= "quelque chose"
frage[136]= "etwas zu trinken"
antwort[136]= "quelque chose  boire"
frage[137]= "das Biskuit/der Keks"
antwort[137]= "le biscuit"
frage[138]= "die Limonade"
antwort[138]= "la limonade"
frage[139]= "Wo sind die Kekse?"
antwort[139]= "O sont les biscuits?"
frage[140]= "Da sind sie!"
antwort[140]= "Les voil!"
frage[141]= "Verflixt nochmal!/Mensch! (Ausruf)"
antwort[141]= "Mince alors!"
frage[142]= "Wo ist...?"
antwort[142]= "O est...?"
frage[143]= "Wo sind...?"
antwort[143]= "O sont...?"
frage[144]= "Was macht...?"
antwort[144]= "Que fait...?"
frage[145]= "Was machen...?"
antwort[145]= "Que font...?"
frage[146]= "Das sind... ."
antwort[146]= "Ce sont... ."
frage[147]= "unter"
antwort[147]= "sous"
frage[148]= "Wo ist der Kassettenrecorder?"
antwort[148]= "O est le magntophone?"
frage[149]= "Da ist er."
antwort[149]= "Le voil!"
frage[150]= "Wohnt die Familie Cartier in Poitiers? "
antwort[150]= "La famille Cartier habite  Poitiers?"
frage[151]= "Natrlich!/Na klar!"
antwort[151]= "Bien su^r!"
frage[152]= "Genau!/Das stimmt!"
antwort[152]= "C'est ca!"
frage[153]= "wohnen= wir wohnen, ihr wohnt/Sie wohnen"
antwort[153]= "habiter= nous habitons, vous habitez"
frage[154]= "eine Tasche"
antwort[154]= "un sac"
frage[155]= "Was ist in der Tasche?"
antwort[155]= "Qu'est-ce qu'il y a dans le sac?"
frage[156]= "Schaut!/Seht!"
antwort[156]= "Regardez!"
frage[157]= "ein Ball"
antwort[157]= "un ballon"
frage[158]= "spielen= wir spielen, ihr spielt/Sie spielen"
antwort[158]= "jouer= nous jouons, vous jouez"
frage[159]= "Fuball spielen"
antwort[159]= "jouer au foot"
frage[160]= "Boules spielen"
antwort[160]= "jouer aux boules"
frage[161]= "Sollen wir Fuball spielen?"
antwort[161]= "On joue au foot?"
frage[162]= "Einverstanden!/O.K.!"
antwort[162]= "D'accord."
frage[163]= "ein Mdchen"
antwort[163]= "une fille"
frage[164]= "Was sollen wir machen?"
antwort[164]= "Qu'est-ce qu'on fait?"
frage[165]= "Und wir Mdchen, was sollen wir machen?"
antwort[165]= "Et nous, les filles, qu'est-ce qu'on fait?"
frage[166]= "ein Junge"
antwort[166]= "un garcon"
frage[167]= "nehmen/einnehmen (+formen pl.+sg. in m.)"
antwort[167]= "prendre= je prends, tu prends, il prend, nous prenons, vous prenez, ils prennent"
frage[168]= "der Aperitif"
antwort[168]= "l'apritif"
frage[169]= "Sie nehmen den Aperitif ein."
antwort[169]= "Ils prennent l'apritif."
frage[170]= "ein Nachbar, eine Nachbarin"
antwort[170]= "un voisin, une voisine"
frage[171]= "der Pastis (+pl.)"
antwort[171]= "le pastis, les pastis"
frage[172]= "der Portwein"
antwort[172]= "le porto"
frage[173]= "der Fruchtsaft, die Fruchtsfte"
antwort[173]= "le jus de fruits, les jus de fruits"
frage[174]= "ich (betonte Form)"
antwort[174]= "moi"
frage[175]= "Ich nehme einen Portwein."
antwort[175]= "Moi, je prends un porto."
frage[176]= "anbieten (+formen pl.+sg. in m.)"
antwort[176]= "offrir= j'offre, tu offres, il offre, nous offrons, vous offrez, ils offrent"
frage[177]= "Sie bietet Herr Durand Kekse an."
antwort[177]= "Elle offre des biscuits  M. Durand."
frage[178]= "eine Kugel"
antwort[178]= "une boule"
frage[179]= "die Partie/das Spiel"
antwort[179]= "le partie"
frage[180]= "Sollen wir eine Partie Boules spielen?"
antwort[180]= "On fait une partie de boules?"
frage[181]= "Spielen wir...!"
antwort[181]= "Jouons...!"
frage[182]= "geben"
antwort[182]= "donner"
frage[183]= "zwei"
antwort[183]= "deux"
frage[184]= "Er gibt Herr Cartier zwei Kugeln."
antwort[184]= "Il donne deux boules  M. Cartier."
frage[185]= "sein= wir sind, ihr seid/Sie sind"
antwort[185]= "etre= nous sommes, vous etes"
frage[186]= "Wir wohnen in Tours."
antwort[186]= "Nous habitons  Tours."
frage[187]= "Wir sind aus Tours."
antwort[187]= "Nous sommes de Tours."
frage[188]= "zeigen"
antwort[188]= "montrer"
frage[189]= "Er zeigt Ren eine Kassette."
antwort[189]= "Il montre une cassette  Ren."
frage[190]= "die Cola"
antwort[190]= "le coca"
frage[191]= "Tennis spielen"
antwort[191]= "jouer au tennis"
frage[192]= "Volleyball spielen"
antwort[192]= "jouer au volley"
frage[193]= "Basketball spielen"
antwort[193]= "jouer au basket"
frage[194]= "Tischtennis spielen"
antwort[194]= "jouer au ping-pong"
frage[195]= "wrfeln/knobeln"
antwort[195]= "jouer aux ds"
frage[196]= "Karten spielen"
antwort[196]= "jouer aux cartes"

end sub

sub Vokabelliste_3()

frage[197]= "ein Geburtstag"
antwort[197]= "un anniversaire"
frage[198]= "Oktober"
antwort[198]= "octobre"
frage[199]= "neun"
antwort[199]= "neuf"
frage[200]= "Wir haben den 9. Oktober./Heute ist der 9. Oktober."
antwort[200]= "On est le neuf octobre."
frage[201]= "eine Stunde"
antwort[201]= "une heure"
frage[202]= "Es ist 1 Uhr."
antwort[202]= "Il est une heure."
frage[203]= "sieben"
antwort[203]= "sept"
frage[204]= "Es ist 7 Uhr."
antwort[204]= "Il est sept heures."
frage[205]= "eine Dusche"
antwort[205]= "une douche"
frage[206]= "Heute habe ich Geburtstag."
antwort[206]= "C'est mon anniversaire aujourd'hui."
frage[207]= "Das ist meine Schwester."
antwort[207]= "Voil ma soeur."
frage[208]= "haben (+ formen im sg.)"
antwort[208]= "avoir= j'ai, tu as, il a"
frage[209]= "eine Klasse"
antwort[209]= "une classe"
frage[210]= "Unterricht haben"
antwort[210]= "avoir classe"
frage[211]= "acht"
antwort[211]= "huit"
frage[212]= "Ich habe um 8 Uhr Unterricht."
antwort[212]= "J'ai classe  huit heures."
frage[213]= "Verflixt!"
antwort[213]= "Zut!"
frage[214]= "schon"
antwort[214]= "dj"
frage[215]= "Marc und seine Mutter"
antwort[215]= "Marc et sa mre"
frage[216]= "Marc und sein Vater"
antwort[216]= "Marc et son pre"
frage[217]= "ein Frhstck"
antwort[217]= "un petit djeuner"
frage[218]= "umarmen/auf die Wange kssen"
antwort[218]= "embrasser"
frage[219]= "ein Sohn, Shne"
antwort[219]= "un fils, des fils"
frage[220]= "eine Tochter"
antwort[220]= "une fille"
frage[221]= "Frau Cartier und ihr Sohn"
antwort[221]= "Mme Cartier et son fils"
frage[222]= "Frau Cartier und ihre Tochter"
antwort[222]= "Mme Cartier et sa fille"
frage[223]= "Herzlichen Glckwunsch (zum Geburtstag)!"
antwort[223]= "Bon anniversaire!"
frage[224]= "die Schokolade/der Kakao"
antwort[224]= "le chocolat"
frage[225]= "franzsische Trinkschale"
antwort[225]= "un bol"
frage[226]= "eine Schale Kakao"
antwort[226]= "un bol de chocolat"
frage[227]= "ein Kaffee/eine Tasse Kaffee"
antwort[227]= "un caf"
frage[228]= "eine Tasse"
antwort[228]= "une tasse"
frage[229]= "Sie nimmt eine Tasse und stellt sie auf den Tisch."
antwort[229]= "Elle prend une tasse et la pose sur la table."
frage[230]= "ein (Butter-)Hrnchen"
antwort[230]= "un croissant"
frage[231]= "ein Geschenk, Geschenke"
antwort[231]= "un cadeau, des cadeaux"
frage[232]= "fr"
antwort[232]= "pour"
frage[233]= "Wir haben ein Geschenk zu deinem Geburtstag."
antwort[233]= "On a un cadeau pour ton anniversaire."
frage[234]= "Da ist deine Mutter."
antwort[234]= "Voil ta mre."
frage[235]= "Da ist dein Vater."
antwort[235]= "Voil ton pre."
frage[236]= "Er nimmt das Geschenk und gibt es Marc."
antwort[236]= "Il prend le cadeau et le donne  Marc."
frage[237]= "ein Paket/Pckchen"
antwort[237]= "un paquet"
frage[238]= "Er nimmt das Paket und ffnet es."
antwort[238]= "Il prend le paquet et l'ouvre."
frage[239]= "Er bedankt sich bei seiner Mutter und bei seinem Vater."
antwort[239]= "Il dit merci  sa mre et  son pre."
frage[240]= "Er umarmt/ksst sie."
antwort[240]= "Il les embrasse."
frage[241]= "ein Fotoapparat, Fotoapparate"
antwort[241]= "un appareil photo, des appareils photo"
frage[242]= "nach der Uhrzeit sehen"
antwort[242]= "regarder l'heure"
frage[243]= "Gut."
antwort[243]= "Bon."
frage[244]= "nun (hier= Ausdruck der Aufforderung)"
antwort[244]= "Eh bien!"
frage[245]= "jetzt"
antwort[245]= "maintenant"
frage[246]= "eine Mappe/Schultasche"
antwort[246]= "une serviette"
frage[247]= "weggehen verschwinden"
antwort[247]= "filer"
frage[248]= "eins, zwei, drei"
antwort[248]= "un, deux, trois"
frage[249]= "vier, fnf, sechs"
antwort[249]= "quatre, cinq, six"
frage[250]= "sieben, acht, neun, zehn"
antwort[250]= "sept, huit, neuf, dix"
frage[251]= "eine zwei"
antwort[251]= "un deux"
frage[252]= "(das) macht"
antwort[252]= "ca fait"
frage[253]= "die Kontrolle"
antwort[253]= "le controle"
frage[254]= "feiern"
antwort[254]= "feter"
frage[255]= "Man feiert.../Wir feiern Geburtstag."
antwort[255]= "On fete l'anniversaire."
frage[256]= "luten/klingeln"
antwort[256]= "sonner"
frage[257]= "Es lutet./Es klingelt."
antwort[257]= "On sonne."
frage[258]= "Da sind Nicole und ihre Brder."
antwort[258]= "Voil Nicole et ses frres."
frage[259]= "Da sind Marc und seine Freunde."
antwort[259]= "Voil Marc et ses amis."
frage[260]= "ein Flugzeug"
antwort[260]= "un avion"
frage[261]= "alle"
antwort[261]= "tout le monde"
frage[262]= "am Tisch"
antwort[262]= " table"
frage[263]= "Alle sind/sitzen am Tisch."
antwort[263]= "Tout le monde est  table."
frage[264]= "noch"
antwort[264]= "encore"
frage[265]= "ein Stck, Stcke"
antwort[265]= "un morceau, des morceaux"
frage[266]= "ein Kuchen, Kuchen"
antwort[266]= "un gateau, des gateaux"
frage[267]= "ein Stck Kuchen"
antwort[267]= "un morceau de gateau"
frage[268]= "Er gibt Pierre ein Stck Kuchen."
antwort[268]= "Il donne un morceau de gateau  Pierre."
frage[269]= "Wem gibt er das Stck Kuchen?"
antwort[269]= "A qui est-ce qu'il donne le morceau de gateau?"
frage[270]= "(Ich mchte) gerne!"
antwort[270]= "Je veux bien!"
frage[271]= "brigens"
antwort[271]= " propos"
frage[272]= "Wie alt bist du?"
antwort[272]= "Tu as quel age?"
frage[273]= "dreizehn"
antwort[273]= "treize"
frage[274]= "ein Jahr"
antwort[274]= "un an"
frage[275]= "Ich bin 13 (Jahre alt)."
antwort[275]= "J'ai treize ans."
frage[276]= "wann"
antwort[276]= "quand"
frage[277]= "Wann hast du Geburtstag?"
antwort[277]= "Quand est-ce que tu as ton anniversaire?"
frage[278]= "Am 5. Mai."
antwort[278]= "Le cinq mai."
frage[279]= "Nun ja!"
antwort[279]= "Eh oui!"
frage[280]= "zusammen"
antwort[280]= "ensemble"
frage[281]= "die Eltern"
antwort[281]= "les parents"
frage[282]= "Wo sind meine Eltern?"
antwort[282]= "O sont mes parents?"
frage[283]= "Da sind deine Eltern."
antwort[283]= "Voil tes parents."
frage[284]= "ein Foto"
antwort[284]= "une photo"
frage[285]= "Wo sollen wir das Foto machen?"
antwort[285]= "O est-ce qu'on prend la photo?"
frage[286]= "ein Balkon"
antwort[286]= "un balcon"
frage[287]= "dann"
antwort[287]= "alors"
frage[288]= "ein Tag"
antwort[288]= "un jour"
frage[289]= "elf, zwlf, dreizehn"
antwort[289]= "onze, douze, treize"
frage[290]= "vierzehn, fnfzehn, sechzehn"
antwort[290]= "quatorze, quinze, seize"
frage[291]= "siebzehn, achtzehn, neunzehn"
antwort[291]= "dix-sept, dix-huit, dix-neuf"
frage[292]= "Christine ist die Freundin von Nicole. Sie ist ihre Freundin."
antwort[292]= "Christine est l'amie de Nicole. C'est son amie."
frage[293]= "Ist das (nicht) Chantal?/Das ist doch Chantal?"
antwort[293]= "C'est bien Chantal?"
frage[294]= "eine Familie"
antwort[294]= "une famille"
frage[295]= "die Mutter"
antwort[295]= "la mre"
frage[296]= "der Vater"
antwort[296]= "le pre"
frage[297]= "die Tochter"
antwort[297]= "la fille"
frage[298]= "der Sohn"
antwort[298]= "le fils"
frage[299]= "die Schwester"
antwort[299]= "la soeur"
frage[300]= "der Bruder"
antwort[300]= "le frre"
frage[301]= "die Freundinnen"
antwort[301]= "les amies"
frage[302]= "die Freunde"
antwort[302]= "les amis"
frage[303]= "eine Freundin"
antwort[303]= "une amie"
frage[304]= "ein Freund"
antwort[304]= "un ami"
frage[305]= "ein Mdchen"
antwort[305]= "une fille"
frage[306]= "ein Junge"
antwort[306]= "un fils"
frage[307]= "eine Nachbarin"
antwort[307]= "une voisine"
frage[308]= "ein Nachbar"
antwort[308]= "un voisin"

end sub

sub Lektion4Button_pressed(self as button)

start_lektion = 197
ende_lektion = 308
position = 197

LektionAktuellPopUp.caption = "Lektion 4 gewhlt"

Neue_Aufgabe()

end sub

sub Lektion3Button_pressed(self as button)

start_lektion = 104
ende_lektion = 196	
position = 104

LektionAktuellPopUp.caption = "Lektion 3 gewhlt"

Neue_Aufgabe()

end sub

