sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim Benchapp as form
Benchapp = MakeComponent("form","app")
CompInit Benchapp
proto="Benchapp"
top=96
left=113
sizeHControl=0
sizeVControl=0
tile=1
caption="Graphik Method Benchmark"
End CompInit
Dim group1 as group
group1 = MakeComponent("group",Benchapp)
CompInit group1
proto="group1"
caption="group1"
look=2
tile=1
tileLayout=1
sizeHControl=2
sizeVControl=0
height=200
tileSpacing=20
visible=1
End CompInit
Dim Pic_Group as group
Pic_Group = MakeComponent("group",group1)
CompInit Pic_Group
proto="Pic_Group"
caption="GString.rectangle()"
look=1
sizeHControl=0
sizeVControl=0
width=210
height=210
tile=1
visible=1
End CompInit
Dim clipper1 as clipper
clipper1 = MakeComponent("clipper",Pic_Group)
CompInit clipper1
proto="clipper1"
tile=1
sizeHControl=0
sizeVControl=0
width=200
height=200
visible=1
End CompInit
Dim picture as picture
picture = MakeComponent("picture",clipper1)
CompInit picture
proto="picture"
height=200
width=200
visible=1
End CompInit
picture.name="picture"
clipper1.name="clipper1"
Pic_Group.name="Pic_Group"
Dim Gad_Group as group
Gad_Group = MakeComponent("group",group1)
CompInit Gad_Group
proto="Gad_Group"
caption="Gadget.DrawRect()"
height=210
width=210
look=1
tile=1
visible=1
End CompInit
Dim clipper2 as clipper
clipper2 = MakeComponent("clipper",Gad_Group)
CompInit clipper2
proto="clipper2"
tile=1
sizeHControl=0
sizeVControl=0
width=200
height=200
visible=1
End CompInit
Dim gadget1 as gadget
gadget1 = MakeComponent("gadget",clipper2)
CompInit gadget1
proto="gadget1"
width=200
height=200
visible=1
End CompInit
gadget1.name="gadget1"
clipper2.name="clipper2"
Gad_Group.name="Gad_Group"
group1.name="group1"
Dim spacer2 as spacer
spacer2 = MakeComponent("spacer",Benchapp)
CompInit spacer2
proto="spacer2"
sizeHControl=2
look=4
visible=1
End CompInit
spacer2.name="spacer2"
Dim group6 as group
group6 = MakeComponent("group",Benchapp)
CompInit group6
proto="group6"
caption="Statistics: delta t in [s]"
look=1
sizeHControl=2
sizeVControl=3
tile=1
tileLayout=1
tileSpacing=6
visible=1
End CompInit
Dim GString as label
GString = MakeComponent("label",group6)
CompInit GString
proto="GString"
caption="rectangle Meth.:"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
GString.name="GString"
Dim entry1 as entry
entry1 = MakeComponent("entry",group6)
CompInit entry1
proto="entry1"
width=100
visible=1
End CompInit
entry1.name="entry1"
Dim label2 as label
label2 = MakeComponent("label",group6)
CompInit label2
proto="label2"
caption="DrawRect() Meth.:"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label2.name="label2"
Dim entry2 as entry
entry2 = MakeComponent("entry",group6)
CompInit entry2
proto="entry2"
width=100
visible=1
End CompInit
entry2.name="entry2"
group6.name="group6"
Dim Option_Name as popup
Option_Name = MakeComponent("popup",Benchapp)
CompInit Option_Name
proto="Option_proto"
caption="Options"
left=0
top=0
visible=1
End CompInit
Dim CLS_Left_Name as button
CLS_Left_Name = MakeComponent("button",Option_Name)
CompInit CLS_Left_Name
proto="CLS_Left_Proto"
caption="Clear Left Screen"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
CLS_Left_Name.name="CLS_Left_Name"
Dim CLS_Right_Name as button
CLS_Right_Name = MakeComponent("button",Option_Name)
CompInit CLS_Right_Name
proto="CLS_Right_Proto"
caption="Clear Right Screen"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
CLS_Right_Name.name="CLS_Right_Name"
Option_Name.name="Option_Name"
Benchapp.width=495
Benchapp.height=333
Benchapp.name="Benchapp"
Dim timedate1 as timedate
timedate1 = MakeComponent("timedate","app")
CompInit timedate1
proto="timedate1"
End CompInit
timedate1.name="timedate1"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
 
        Benchapp.visible = TRUE

        DIM starttime   AS LONG
        DIM seconds     AS INTEGER
        update()        REM UI-Neuaufbau soll die Messung nach Mglichkeit nicht stren.
        starttime = timedate1.systemClock

        DIM XCount              AS INTEGER
        DIM YCount              AS INTEGER


        DIM GStringT AS COMPONENT
        GStringT = MakeComponent("draw", "top")

        GStringT.start()
                
                FOR XCount = 1 TO 49 STEP 1
                        
                        FOR YCount = 1 TO 49 STEP 1                     
                                
                                GStringT.rectangle( (XCount * 4) - 1, (YCount * 4) - 1, (XCount * 4) + 1, (YCount * 4) + 1 ) 

                        NEXT YCount

                NEXT XCount
                
        GStringT.stop()
        
        picture.graphic = GStringT.data 

        seconds = timedate1.systemClock - starttime

        entry1.text = STR (seconds/1000) + "." + STR (seconds mod 1000) + " s"

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear


end sub

sub module_hide()
REM code for making this module disappear


end sub

sub module_exit()

end sub

sub gadget1_draw(self as gadget)
        update()
        starttime = timedate1.systemClock

        DIM XCount              AS INTEGER
        DIM YCount              AS INTEGER

        FOR XCount = 1 TO 49 STEP 1

                FOR YCount = 1 TO 49 STEP 1                     

                        self.DrawRect ( (XCount * 4) - 1, (YCount * 4) - 1, (XCount * 4) + 1, (YCount * 4) + 1, BLACK ) 

                NEXT YCount

        NEXT XCount

        seconds = timedate1.systemClock - starttime
        
        entry2.text = STR (seconds/1000) + "." + STR (seconds mod 1000) + " s"

end sub

sub CLS_Left_Proto_pressed(self as button)
DIM CLS_Complex AS COMPLEX

picture.graphic = CLS_Complex





end sub

